// GrobalMain.h: CGrobalMain NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_)
#define AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/// Classes ////////
#include "DirectDraw.h"
#include "DirectDrawSurface.h"
#include "DirectSound.h"
#include "DirectSoundBuffer.h"
#include "DirectInput.h"
#include "DirectMusic.h"
#include "DirectMusicSegment.h"

#include "Block.h"
#include "BattleField.h"

class CGrobalMain
{
	friend class CDirectSoundBuffer;
public:
	CGrobalMain();
	virtual ~CGrobalMain();

	void Start( HINSTANCE hi,HWND hw );
	void End();

	void BattleProc();

	void Timer( UINT ID );
	void Activate( BOOL bAtctive );
	void EndTimer();
	void StartTimer();

	static void CALLBACK MMTimerProc( UINT uID , UINT uMsg , DWORD dwUser , DWORD dw1 , DWORD dw2 );

	// J\[X
	CDirectDrawSurface m_Back;
	CDirectDrawSurface m_ImageList[15];

private:
	UINT m_TimerID;
	HWND m_hWnd;
	HINSTANCE m_hInstance;
	bool m_bActive;
	CDirectDraw dd;
	CDirectDrawSurface* pbk;
	CDirectSound ds;
	CDirectInput di;
	CDirectMusic dm;

protected:

	// J\[X
	CDirectMusicSegment m_Bgm;

	// MODE BATTLE
	CBlock m_CurBlock;
	CBattleField m_Field;

	char m_LastKey[256];
	int m_Rensa;

	enum { TITLE , BATTLE , DEADEND } m_Mode;
	enum { INIT , FALL , JUDGE_B , JUDGE_ES , JUDGE_EW , JUDGE_ER } m_ModeDetail;
};

#endif // !defined(AFX_GROBALMAIN_H__077C6483_935D_11D2_B314_DE15839C9229__INCLUDED_)
